dnl acinclude.m4 generated automatically by ac-archive's acinclude 0.5.63

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

dnl ______  ______

dnl ______ acpackage.m4 ______
# _DA_BOOST_VER([VERSION=0])
# --------------------------
# Test if boost version >= VERSION
m4_define([_DA_BOOST_VER],
[
  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS[]dnl
  DA_OLD_CPPFLAGS="$CPPFLAGS"
  DA_MIN_VERSION=ifelse([$1], ,0,[$1])
  AC_TRY_COMPILE([#include <boost/version.hpp>],
[#if BOOST_VERSION >= $DA_MIN_VERSION
// Everything is okay
#else
#error Boost version is too old
#endif],
                 [da_have_boost="new"],
                 [da_have_boost="old"])[]dnl
  CPPFLAGS="$DA_OLD_CPPFLAGS"[]dnl
  AC_LANG_RESTORE[]dnl
])# _DA_BOOST_VER

# DA_BOOST([MINIMUM-VERSION], [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND], [EXTRA-DIRS])
# -----------------------------------------------------------------------------------
# Test for the Boost C++ libraries of a particular versin (or newer)
# Searching in the EXTRA-DIRS if given.
# Defines:
#    BOOST_CPPFLAGS to the set of flags requierd to compile Boost
AC_DEFUN([DA_BOOST], 
[
  AC_SUBST(BOOST_CPPFLAGS)
  AC_SUBST(BOOST_LIBS)
  BOOST_CPPFLAGS=""
# path_given="no"
# Extract the path name from a --with-boost=PATH argument
  AC_ARG_WITH([boost],
              AC_HELP_STRING([--with-boost=PATH],
                             [absolute path name where the Boost C++ libraries reside, or `int', for internal library. Alternatively, the BOOST_ROOT environment variable will be used]),
                             [if test "$withval" != yes ; then
                                BOOST_ROOT="$withval"
                              fi])
  da_boost_min_version=ifelse([$1], ,1.20.0,[$1])
  WANT_BOOST_MAJOR=`expr $da_boost_min_version : '\([[0-9]]\+\)'`
  WANT_BOOST_MINOR=`expr $da_boost_min_version : '[[0-9]]\+\.\([[0-9]]\+\)'`
  WANT_BOOST_SUB_MINOR=`expr $da_boost_min_version : '[[0-9]]\+\.[[0-9]]\+\.\([[0-9]]\+\)'`
  AC_MSG_CHECKING([for the Boost C++ libraries, version $da_boost_min_version or newer])
  for BOOST_ROOT in $4 "/usr/local" "/usr"; do
    for BOOST_DIR in `ls -rd $BOOST_ROOT/include/boost*`; do
      BOOST_CPPFLAGS="-I$BOOST_DIR"
      CPPFLAGS="$OLD_CPPFLAGS $BOOST_CPPFLAGS"[]dnl
      _DA_BOOST_VER[]dnl
      if test "x$da_have_boost" != "xnew"; then
	  have_boost="no"
      else
        WANT_BOOST_VERSION=`expr $WANT_BOOST_MAJOR \* 100000 \+ $WANT_BOOST_MINOR \* 100 \+ $WANT_BOOST_SUB_MINOR`[]dnl
        _DA_BOOST_VER([$WANT_BOOST_VERSION])[]dnl
        if test "x$da_have_boost" = "xnew"; then
	    break
        fi
      fi
    done
    if test "x$da_have_boost" = "xnew"; then
      break
    fi
  done
  case $da_have_boost in
  "no")
        AC_MSG_RESULT([no])
        ifelse([$3], , :, [$3])
	;;
  "old")
        AC_MSG_RESULT([no, version of installed Boost libraries is too old])
        ifelse([$3], , :, [$3])
	;;
  "new")
	AC_MSG_RESULT([yes])
	if test "$target_os" = "mingw32"; then
	   boost_libsuff=mgw
	else
	   boost_libsuff=gcc
	fi
	boost_libsuff_r=$boost_libsuff-mt;
	if test "x$enable_debug" = xyes ; then
	    boost_libsuff=$boost_libsuff-d;
	    boost_libsuff_r=$boost_libsuff_r-d;
	fi
	boost_libsuff=$boost_libsuff-${WANT_BOOST_MAJOR}_$WANT_BOOST_MINOR
	boost_libsuff_r=$boost_libsuff_r-${WANT_BOOST_MAJOR}_$WANT_BOOST_MINOR
        ifelse([$2], , :, [$2])
	;;
  esac[]dnl
])# DA_BOOST

dnl DA_BOOST_TEST([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND], [NAME], [INCLUDES], [CODE])
dnl Test for the Boost [NAME] library
dnl Defines
dnl   BOOST_LDFLAGS to the set of flags required to compile boost_[NAME]
AC_DEFUN([DA_BOOST_TEST],
[
  AC_REQUIRE([DA_BOOST])
  AC_MSG_CHECKING([whether we can use the boost::$3 library])
  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS
  OLD_CPPFLAGS="$CPPFLAGS"
  CPPFLAGS="$BOOST_CPPFLAGS" # -D_REENTRANT"
  OLD_LIBS="$LIBS"
  LIBS="-lboost_$3-$boost_libsuff"
  LIBS_R="-lboost_$3-$boost_libsuff_r"
    AC_TRY_COMPILE(
	    [$4],
	    [$5],
	    [
		AC_MSG_RESULT([yes])
		ifelse([$1], , :, [$1])
	    ],
	    [ 
		AC_MSG_RESULT([no])
		ifelse([$2], , :, [$2])
	    ])

    AC_SUBST(BOOST_CPPFLAGS)
    AC_SUBST(BOOST_LIBS)
    AC_SUBST(BOOST_LIBS_R)
    BOOST_CPPFLAGS="$CPPFLAGS"
    BOOST_LIBS="$LIBS $BOOST_LIBS"
    BOOST_LIBS_R="$LIBS_R $BOOST_LIBS_R"
    CPPFLAGS="$OLD_CPPFLAGS"
    LIBS="$OLD_LIBS"
    AC_LANG_RESTORE
])

dnl DA_BOOST_PROGRAM_OPTIONS([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
dnl Test for the Boost program_options library
dnl Defines
dnl   BOOST_LDFLAGS to the set of flags required to compile boost_program_options
AC_DEFUN([DA_BOOST_PROGRAM_OPTIONS], 
[
  DA_BOOST_TEST([$1],[$2],[program_options],
	    [ 
		#include <boost/program_options.hpp> 
	    ],
	    [
		using namespace boost::program_options;
		return 0;
	    ])
])

dnl DA_BOOST_THREAD([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
dnl Test for the Boost thread library
dnl Defines
dnl   BOOST_LDFLAGS to the set of flags required to compile boost_thread
AC_DEFUN([DA_BOOST_THREAD], 
[
  ifelse(
  DA_BOOST_TEST([$1],[$2],[thread],[
		#include <boost/thread.hpp> 
		bool bRet = 0;
		void thdfunc() { bRet = 1; }
	],
	[
		boost::thread thrd(&thdfunc);
		thrd.join();
		return bRet == 1;
	])
  )# ifelse
])

dnl DA_BOOST_DATE_TIME([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
dnl Test for the Boost date_time library
dnl Defines
dnl   BOOST_LDFLAGS to the set of flags required to compile boost_date_time
AC_DEFUN([DA_BOOST_DATE_TIME], 
[
	DA_BOOST_TEST([$1],[$2],[date_time],
	    [ 
		#include <boost/date_time/gregorian/gregorian.hpp> 
	    ],
	    [
		using namespace boost::gregorian;
		date d = from_string("1978-01-27");
		return d == boost::gregorian::date(1978, Jan, 27);
	    ])
])

dnl DA_BOOST_REGEX([ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
dnl Test for the Boost regex library
dnl Defines
dnl   BOOST_LDFLAGS to the set of flags required to compile boost_regexp
AC_DEFUN([DA_BOOST_REGEX], 
[
	DA_BOOST_TEST([$1],[$2],[regexp],
	    [ 
		#include <boost/regex.hpp> 
	    ],
	    [
		using namespace boost;
		cmatch what;
		if(!regex_match("27/01/78",what,regex("(\\\d+)/(\\\d+)/(\\\d+)")))
		    return 0;

		return what[1]=="27" && what[2]=="01" && what[3]=="78";
	    ])
])

