/**************************************************************************************************

AtMost.h -- (C) Daniel Andrn, 2005

Defines the constraint AtMost supported by UmSat

**************************************************************************************************/

#ifndef AtMost_h
#define AtMost_h

#include "BaseConstraint.h"
#include "SolverTypes.h"

//=================================================================================================
// AtMost:


class AtMost : public BaseConstraint {
    int     n;
    int     counter;
    int     size;
    Lit     lits[0];

public:
    // Constructor -- creates a new AtMost-constraint and add it to watcher lists.
    friend bool AtMost_new(Solver& S, const vec<Lit>& ps, int n, AtMost*& out);

    // Constraint interface:
    void remove    (Solver& S, bool just_dealloc = false);
    bool propagate (Solver& S, Lit p, bool& keep_watch);
    bool simplify  (Solver& S);
    void undo      (Solver& S, Lit p);
    void calcReason(Solver& S, Lit p, vec<Lit>& out_reason);
    const char *name(void) { return "AtMost"; }
};


//=================================================================================================

#endif




