/**************************************************************************************************

BaseConstraints.C -- (C) Niklas Een, Niklas Srensson, 2004

Defines the base constraint supported by UmSat.

**************************************************************************************************/

#include "BaseConstraint.h"

//=================================================================================================
// Helpers:

void removeWatch(vec<BaseConstraint*>& ws, BaseConstraint* elem)
{
    int j = 0;
    for (; ws[j] != elem  ; j++) assert(j < ws.size());
    for (; j < ws.size()-1; j++) ws[j] = ws[j+1];
    ws.pop();
}

void removeIfWatch(vec<BaseConstraint*>& ws, BaseConstraint* elem)
{
    int j = 0;
    bool pop = false;
    for (; (j < ws.size()) && (ws[j] != elem)  ; j++) assert(j < ws.size());
    if(ws[j] == elem) pop = true;
    for (; j < ws.size()-1; j++) ws[j] = ws[j+1];
    if(pop) ws.pop();
}
