/**************************************************************************************************

Imply.h -- (C) Daniel Andrn, 2004

Defines the constraint Imply supported by UmSat.

**************************************************************************************************/

#ifndef Imply_h
#define Imply_h

#include "BaseConstraint.h"
#include "SolverTypes.h"

//=================================================================================================
// Imply:


class Imply : public BaseConstraint {
    int     size;
    Lit     c;
    Lit     lits[0];

public:
    // Constructor -- creates a new And-constraint and add it to watcher lists.
    friend bool Imply_new(Solver& S, const Lit c, const vec<Lit>& ps, Imply*& out);

    // Constraint interface:
    void remove    (Solver& S, bool just_dealloc = false);
    bool propagate (Solver& S, Lit p, bool& keep_watch);
    bool simplify  (Solver& S);
    void undo      (Solver& S, Lit p);
    void calcReason(Solver& S, Lit p, vec<Lit>& out_reason);
    const char *name(void) { return "mply"; }
};


//=================================================================================================

#endif
