/**************************************************************************************************

Xor.h -- (C) Daniel Andrn, 2004

Defines the constraint Xor supported by UmSat.

**************************************************************************************************/

#ifndef Xor_h
#define Xor_h

#include "BaseConstraint.h"
#include "SolverTypes.h"

//=================================================================================================
// Xor:


class Xor : public BaseConstraint {
    int     par;
    int     nvars;
    int     size;
    // int     idx;
    Lit     lits[0];

public:
    // Constructor -- creates a new Xor-constraint and add it to watcher lists.
    friend bool Xor_new(Solver& S, const vec<Lit>& ps, Xor*& out);

    // Constraint interface:
    void remove    (Solver& S, bool just_dealloc = false);
    bool propagate (Solver& S, Lit p, bool& keep_watch);
    bool simplify  (Solver& S);
    void undo      (Solver& S, Lit p);
    void calcReason(Solver& S, Lit p, vec<Lit>& out_reason);
    const char *name(void) { return "Xor"; }
};


//=================================================================================================

#endif




