/**************************************************************************************************

debug.h -- (C) Daniel Andrn, 2004

Debugging routines.

**************************************************************************************************/

#ifndef __debug_h__
#define __debug_h__

#define NONE 0
#define BEFORE 1
#define AFTER 2
#define ALL (BEFORE | AFTER)

// For derivation output (verbosity level 2)
#define L_IND    "c %-*d"
#define L_ind    S.decisionLevel()*3+3,S.decisionLevel()
#define L_LIT    "%sx%d"
#define L_lit(p) sign(p)?"~":"", var(p)

#ifdef NDEBUG
//const int debuglevel = 0;
#undef DEBUG
#endif

#ifdef DEBUG

#include <stdio.h>
#include <stdarg.h>

#define OUTFH stderr

#endif

const char *L_val(Lit l,Solver& S);
// void debugprint(int level, int indent, int nl, const char* fmt, ...);

#endif
