/**************************************************************************************************

jmf.h -- (C) Daniel Andrn, 2004

Defines the constraints supported by MiniSat.

**************************************************************************************************/

#ifndef jmf_h
#define jmf_h

#include "BaseConstraint.h"
#include "SolverTypes.h"

//=================================================================================================
// jmf:


class jmf : public BaseConstraint {
    int     size;
    int     mw;
    Lit     lits[0];

    
public:
    // Constructor -- creates a new jmf-constraint and add it to watcher lists.
    friend bool jmf_new(Solver& S, const vec<Lit>& ps, const vec<Lit>& qs, jmf*& out);

    // Constraint interface:
    void remove    (Solver& S, bool just_dealloc = false);
    bool propagate (Solver& S, Lit p, bool& keep_watch);
    bool simplify  (Solver& S);
    void undo      (Solver& S, Lit p);
    void calcReason(Solver& S, Lit p, vec<Lit>& out_reason);
    const char *name(void) { return "jmf"; }

private:
    void add_watch (Solver& S, int i);
};


//=================================================================================================

#endif




