/**************************************************************************************************

Stats.C -- (C) Daniel Andrén, 2004

Defines some functions for printing statistics for MiniSat.

**************************************************************************************************/

#include "Solver.h"
#include "Stats.h"

//=================================================================================================

void printStats(SolverStats& stats, double cpu_time)
{
    printf("c starts       : %5"I64_fmt"\n", stats.starts);
    printf("c conflicts    : %5"I64_fmt"   (%.0f /sec)\n", stats.conflicts   , stats.conflicts   /cpu_time);
    printf("c decisions    : %5"I64_fmt"   (%.0f /sec)\n", stats.decisions   , stats.decisions   /cpu_time);
    printf("c propagations : %5"I64_fmt"   (%.0f /sec)\n", stats.propagations, stats.propagations/cpu_time);
    printf("c inspects     : %5"I64_fmt"   (%.0f /sec)\n", stats.inspects    , stats.inspects    /cpu_time);
    printf("c CPU time     : %5g s\n", cpu_time);

    printf("\n\n");
    PROPF("AtMost", stats.propm);
    PROPF("Xor"   , stats.propx);
    PROPF("Imply" , stats.propi);
    PROPF("jmf"   , stats.propj);
    for(int i = 1; i < NPROP; ++i)
      PROPF2(i+1,stats.prop[i]);
    printf("c     tot      : %5"I64_fmt"\n", stats.prop[0]);
}

//=================================================================================================
